/*
 * Copyright(C) 2018, SDT
 *
 * Filename:
 *     samtool.h
 * 
 * Description:
 *     
 *
 * Version:
 *     $Id: samtool.h, v0.1, 2018/07/01, caizf, create$
 *
 * Logs:
 *     $Log: caizf, 2018/07/01, create$
 *
 */

#ifndef __SAMTOOL_H__
#define __SAMTOOL_H__

#define PVISIBILITY_DEFAULT __attribute__((visibility("default")))
#define PEXPORT PVISIBILITY_DEFAULT

typedef unsigned long ULONG;
typedef char * LPSTR;
typedef char BYTE;

#define SAR_OK		0x00000000
#define SAR_ERR		0x0A000000
#define SAR_FAIL				(SAR_ERR+0x1)
#define SAR_UNKNOWERR			(SAR_ERR+0x2)
#define SAR_VERIFY				(SAR_ERR+0x3)
#define SAR_VERIFY_CERT			(SAR_ERR+0x4)


PEXPORT ULONG	SMT_VerifyCert(LPSTR szCert, ULONG ulCertLen);
/*
SMT_VerifySign()
LPSTR szData      //data protected with signature
ULONG ulDataLen 	//data byte length
LPSTR szSign			//signature
ULONG ulSignLen		//signature byte length
LPSTR szCert			//sam cert, read from sam api SDT_GetSAMCert()
ULONG ulCertLen		//sam cert byte length
*/
PEXPORT ULONG	SMT_VerifyCert(LPSTR szCert, ULONG ulCertLen);
PEXPORT ULONG	SMT_VerifySign(LPSTR szData, ULONG ulDataLen, LPSTR szSign, ULONG ulSignLen, LPSTR szCert, ULONG ulCertLen);
PEXPORT int genHashIdencode(unsigned char const ID_NUM[18], unsigned char ucIDnumLen, unsigned char const pucInRand[16], unsigned char pucIdencode[64]);

#endif //__SAMTOOL_H__
